//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   5 Jun 06  Brian Frank  Creation
//

**
** PodDef models the pod being compiled.
**
class PodDef : DefNode, CPod
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  new make(Namespace ns, Location location, Str name)
    : super(location)
  {
    this.ns = ns
    this.name = name
  }

//////////////////////////////////////////////////////////////////////////
// CPod
//////////////////////////////////////////////////////////////////////////

  override CType findType(Str name)
  {
// TODO - this sucks
    return types.find |CType t->Bool| { return t.name == name }
  }

  override CType[] types()
  {
    acc := CType[,]
    units.each |CompilationUnit unit| { acc.addAll(unit.types) }
    return acc
  }

//////////////////////////////////////////////////////////////////////////
// Debug
//////////////////////////////////////////////////////////////////////////

  override Void print(AstWriter out)
  {
    out.nl
    out.w("======================================").nl
    out.w("pod $name").nl
    out.w("======================================").nl
    units.each |CompilationUnit unit| { unit.print(out) }
    out.nl
  }

  override Str toStr()
  {
    return "pod $name"
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  override readonly Namespace ns    // compiler's namespace
  override readonly Str name        // simple pod name
  CompilationUnit[] units           // Tokenize

}