//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   4 Jun 06  Brian Frank  Creation
//

**
** ImportedPod is the implementation of CPod for an imported pod
** which is already compiled.
**
class ImportedPod : CPod
{

  new make(Namespace ns, Pod pod)
  {
    this.ns = ns
    this.pod = pod
  }

  override readonly Namespace ns

  override Str name() { return pod.name }

  override readonly CType[] types
  {
    get
    {
      if (@types == null) @types = ns.importTypes(pod.types)
      return @types
    }
  }

  override CType findType(Str typeName)
  {
    t := pod.findType(typeName, false)
    if (t == null) return null
    return ns.importType(t)
  }

  override Str toStr()
  {
    return name
  }

  readonly Pod pod

}