//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   02 Jul 06  Andy Frank  Creation
//

using web

**
** FandocIndex.
**
class FandocIndex : FandocWeblet
{

//////////////////////////////////////////////////////////////////////////
// Weblet
//////////////////////////////////////////////////////////////////////////

  override Void get()
  {
    pods := Pod.list

    doHeader("All Pods - Fandoc")

    out.div("class='header'")
    out.table("width='100%' cellspacing='0' cellpadding='0'")
    out.tr
    out.td.w("All Pods").tdEnd
    out.td("style='text-align: right;'")
    doSearch()
    out.tdEnd

    out.trEnd
    out.tableEnd
    out.divEnd

    out.div("class='content'")
    writeTable("All Pods", pods)
    out.divEnd

    doFooter
  }

  **
  ** Write out the table for these types.
  **
  Void writeTable(Str title, Pod[] pods)
  {
    if (pods.isEmpty) return

    out.div("class='slotTable'")
    out.h1(title)
    out.table("width='100%' cellspacing='0' cellpadding='0'")
    pods.each |Pod p, Int i|
    {
      cls := (i % 2 == 0) ? "rowEven" : "rowOdd"

      out.tr

      out.td("class='$cls col2'")
      out.a(podUri(p)).w(p.name).aEnd.br.nl
      out.tdEnd

      out.td("class='$cls col3'")
      out.w(p.version.toStr).nl
      out.tdEnd

      out.td("width='100%' class='$cls col3'")
      descr := p.facets["description"]
      if (descr != null)
        out.w(safe(descr))
      else
        out.w("&nbsp;") // b/c IE sucks
      out.tdEnd

      out.trEnd
    }
    out.tableEnd
    out.divEnd
  }

}