//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   02 Aug 06  Andy Frank  Creation
//

/**
 * Make protected, private, and interal slots visible.
 */
function showAllSlots()
{
  var elems = getElementsByClassName("hidden")
  for (var i=0; i<elems.length; i++)
    trOn(elems[i]);
}

/**
 * Expand the fandoc associated with this slot.
 */
function showFulldoc(event)
{
  var target = (event.target) ? event.target : window.event.srcElement;
  var sum  = target.parentNode;
  var full = sum.nextSibling;
  while (full.nodeName != "DIV")
    full = full.nextSibling;
  
  sum.style.display = "none";
  sum.style.visibility = "hidden";  

  full.style.display = "block";
  full.style.visibility = "visible";    
}

/**
 * Return all elements that have this classname.
 */
function getElementsByClassName(className)
{
  var match = new Array();
  var kids = document.body.getElementsByTagName('*');  
  
  for (var i=0; i<kids.length; i++)
  {
    if (kids[i].className.match("hidden"))
      match.push(kids[i])
  }
  
  return match;
}

/**
 * Make this tr element visible.
 */
function trOn(tr)
{
  tr.style.display = "block";
  tr.style.visibility = "visible";
  try 
  { 
    // Firefox
    tr.style.display = "table-row";
  }
  catch(e) 
  {
    // IE, Safari 
    tr.style.display = 'block';
  }
}



