//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   17 Jun 06  Brian Frank  Creation
//
package fan.sys;

/**
 * Obj is the root type for all classes and mixins in Fan.  It's an interface
 * so that it can handle mixin interfaces.  The root class is FanObj.
 */
public interface Obj
{

  public Bool equals(Obj obj);

  public Int compare(Obj obj);

  public Int hash();

  public Str toStr();

  public Bool isImmutable();

  public Type type();

  public Obj trap(Str name, List args);

  public Obj trapUri(Uri uri);

}