//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   28 Jan 06  Brian Frank  Creation
//
package fanx.compiler.ast;

import fanx.compiler.*;

/**
 * Break out of while or for
 */
public class BreakStmt
  extends Stmt
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public BreakStmt(ILocation location)
  {
    super(location);
  }

//////////////////////////////////////////////////////////////////////////
// Stmt
//////////////////////////////////////////////////////////////////////////

  public int id()
  {
    return BREAK;
  }

//////////////////////////////////////////////////////////////////////////
// Debug
//////////////////////////////////////////////////////////////////////////

  public String toString()
  {
    return "break";
  }

  public void tree(AstWriter out)
  {
    out.w("BreakStmt").nl();
  }

  public void pretty(AstWriter out)
  {
    out.w("break;").nl();
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  public Stmt loop;   // loop to break out of

}