//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   15 Dec 05  Brian Frank  Creation
//
package fanx.compiler.ast;

import fan.sys.*;
import fanx.compiler.*;

/**
 * SlotDef is the superclass of FieldDef and MethodDef
 */
public abstract class SlotDef
  extends DefNode
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public SlotDef(ILocation location)
  {
    super(location);
  }

//////////////////////////////////////////////////////////////////////////
// Convenience
//////////////////////////////////////////////////////////////////////////

  public boolean isStaticInit()
  {
    return false; // used only by Method
  }

  public boolean isFieldAccessor()
  {
    return false; // used only by Method
  }

  public abstract Slot slot();

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  public String name;

}