//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   25 Dec 05  Brian Frank  Creation
//
package fanx.compiler.steps;

import java.io.*;
import java.util.*;
import fan.sys.*;
import fanx.compiler.*;
import fanx.compiler.Compiler;

/**
 * InitShimPod is used to initialize Compiler.pod with a ShimPod that represents
 * the Pod being compiled before it has been committed to the Sys namespace.
 */
public class InitShimPod
  extends CompilerStep
{

  public InitShimPod(Compiler compiler, String podName)
  {
    super(compiler);
    this.podName = podName;
  }

  public InitShimPod(Compiler compiler)
  {
    this(compiler, null);
  }

  public void run()
  {
    if (podName == null)
    {
      // for now just use directory name
      podName = compiler.srcDir.getName();
    }

    compiler.pod = new ShimPod(podName);
    compiler.isSys = podName.equals("sys");
  }

  String podName;
}