//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   19 Mar 06  Brian Frank  Creation
//
package fanx.emit;

import java.util.*;
import fan.sys.*;
import fanx.fcode.*;
import fanx.util.*;

/**
 * FClassEmit emits a normal class type.
 */
public class FClassEmit
  extends FTypeEmit
  implements FConst
{

//////////////////////////////////////////////////////////////////////////
// Constructor
//////////////////////////////////////////////////////////////////////////

  public FClassEmit(Type parent, FType type)
  {
    super(parent, type);
  }

//////////////////////////////////////////////////////////////////////////
// Overrides
//////////////////////////////////////////////////////////////////////////

  protected String base()
  {
    // if the base is a generic instance, then this must be a closure
    // method type (since we can't subclass List or Map).  We subclass
    // from one of the canned Method.Indirect inner classes.
    FTypeRef ref = pod.typeRef(type.base);
    if (ref.isGenericInstance())
    {
      this.methodType = (MethodType)Type.find(ref.sig, true);
      int paramCount = methodType.params.length;
      if (paramCount  > Method.MaxIndirectParams)
        return "fan/sys/Method$IndirectX";
      else
        return "fan/sys/Method$Indirect" + paramCount;
    }
    else
    {
      String base = jname(type.base);
      if (base.equals("fan/sys/Obj")) return "fan/sys/FanObj";
      return base;
    }
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

}