//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   26 Dec 05  Brian Frank  Creation
//
package fanx.fcode;

import java.io.*;
import fanx.util.*;

/**
 * FFacet is meta-data for a FType of FSlot
 */
public class FFacet
  implements FConst
{

  public FFacet(int name, int flags, FBuf data)
  {
    this.name  = name;
    this.flags = flags;
    this.data  = data;
  }

  public FFacet()
  {
  }

  public static FFacet facet(FPod pod, FFacet[] facets, String name)
  {
    if (facets != null)
    {
      for (int i=0; i<facets.length; ++i)
        if (pod.name(facets[i].name).equals(name))
          return facets[i];
    }
    return null;
  }

  public void write(FStore.Output out) throws IOException
  {
    out.u2(name);
    out.u1(flags);
    FBuf.write(out, data);
  }

  protected FFacet read(FStore.Input in) throws IOException
  {
    name = in.u2();
    flags = in.u1();
    data = FBuf.read(in);
    return this;
  }

  public static final FFacet[] None = new FFacet[0];

  public int name;    // name index
  public int flags;
  public FBuf data;

}