//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   18 Oct 06  Andy Frank  Creation
//

using System;

namespace Fan.Sys
{
  /// <summary>
  /// ArgErr
  /// </summary>
  public class ArgErr : Err
  {

  //////////////////////////////////////////////////////////////////////////
  // C# Convenience
  //////////////////////////////////////////////////////////////////////////

    public new static ArgErr Make(string msg)  { return Make(Str.Make(msg)); }
    public static ArgErr Make(Int index)   { return Make(Str.Make(index.ToString())); }
    //public new static ArgErr Make(Range index) { return Make(Str.make(index.ToString()))); }

  //////////////////////////////////////////////////////////////////////////
  // Fan Constructors
  //////////////////////////////////////////////////////////////////////////

    public new static ArgErr Make() { return Make((Str)null, (Err)null); }
    public new static ArgErr Make(Str msg) { return Make(msg, null); }
    public new static ArgErr Make(Str msg, Err cause)
    {
      ArgErr err = new ArgErr();
      Make_(err, msg, cause);
      return err;
    }

    public static void Make_(ArgErr self) { Make_(self, null);  }
    public static void Make_(ArgErr self, Str msg) { Make_(self, msg, null); }
    public static void Make_(ArgErr self, Str msg, Err cause) { Err.Make_(self, msg, cause); }

  //////////////////////////////////////////////////////////////////////////
  // Java Constructors
  //////////////////////////////////////////////////////////////////////////

    public ArgErr(Err.Val val) : base(val) {}
    public ArgErr() : base(new ArgErr.Val()) {}
    public ArgErr(Exception actual) : base(new ArgErr.Val(), actual) {}

  //////////////////////////////////////////////////////////////////////////
  // Identity
  //////////////////////////////////////////////////////////////////////////

    public override Type Type() { return Sys.ArgErrType; }

  //////////////////////////////////////////////////////////////////////////
  // Val - Java Exception Type
  //////////////////////////////////////////////////////////////////////////

    public new class Val : Err.Val {}

  }
}