//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   16 Jan 07  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// InStream interface.
  /// </summary>
  public interface InStream
  {

    int R();
    int RChar();

    Int Read();

    //Int ReadBuf(Buf buf, Int n);

    InStream Unread(Int n);
    InStream Unread(int n);

    //Buf ReadAllBuf();
    //Buf ReadBufFully(Buf buf, Int n);

    Int ReadU1();

    Int ReadS1();

    Int ReadU2();

    Int ReadS2();

    Int ReadU4();

    Int ReadS4();

    Int ReadS8();

    Float ReadF4();

    Float ReadF8();

    Bool ReadBool();

    Str ReadUtf();

    //Charset Charset();

    //void SetCharset(Charset charset);

    Int ReadChar();

    InStream UnreadChar(Int c);

    Str ReadLine();

    List ReadAllLines();

    Str ReadAllStr();
    Str ReadAllStr(Bool normalizeNewlines);

    Map ReadProps();

    Int Pipe(OutStream output);
    Int Pipe(OutStream output, Int n);
    Int Pipe(OutStream output, Int n, Bool close);

    Bool Close();

  }
}