//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   28 Sep 06  Andy Frank  Creation
//

using System;

namespace Fan.Sys
{
  /// <summary>
  /// MethodParam represents one formal parameter to a Method.
  /// </summary>
  public class MethodParam : FanObj
  {

  //////////////////////////////////////////////////////////////////////////
  // Constructor
  //////////////////////////////////////////////////////////////////////////

    public MethodParam(Str name, Type paramType, int mask)
    {
      this.name      = name;
      this.paramType = paramType;
      this.mask      = mask;
    }

  //////////////////////////////////////////////////////////////////////////
  // Methods
  //////////////////////////////////////////////////////////////////////////

    public override Type Type() { return Sys.MethodParamType; }

    public Str Name()        { return name; }
    public Type ParamType()  { return paramType; }
    public Bool HasDefault() { return Bool.Make(mask & HAS_DEFAULT); }

    public override Str ToStr() { return Str.Make(paramType + " " + name); }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

    public static readonly int HAS_DEFAULT   = 0x01;  // is a default value provided

    internal readonly Str name;
    internal readonly Type paramType;
    internal readonly int mask;

  }
}