//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   14 Sep 06  Andy Frank  Creation
//

using System;

namespace Fan.Sys
{
  ///
  /// Obj is the root type for all classes and mixins in Fan.  It's an interface
  /// so that it can handle mixin interfaces.  The root class is FanObj.
  ///
  public interface Obj
  {
    Bool Equals(Obj obj);

    Int Compare(Obj obj);

    Int Hash();

    Str ToStr();

    Type Type();

    Obj Trap(Str name, List args);

    //public Obj trapUri(Uri uri);
  }
}