//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   16 Jan 07  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// OutStream interface.
  /// </summary>
  public interface OutStream
  {

    OutStream W(int b);

    OutStream Write(Int x);

    //OutStream WriteBuf(Buf buf);
    //OutStream WriteBuf(Buf buf, Int n);

    OutStream WriteI2(Int x);

    OutStream WriteI4(Int x);

    OutStream WriteI8(Int x);

    OutStream WriteF4(Float x);

    OutStream WriteF8(Float x);

    OutStream WriteBool(Bool x);

    OutStream WriteUtf(Str x);

    //Charset Charset();

    //void SetCharset(Charset charset);

    OutStream WriteChar(Int c);

    OutStream WriteChars(Str s);
    OutStream WriteChars(Str s, Int off);
    OutStream WriteChars(Str s, Int off, Int len);

    OutStream Print(Obj s);

    OutStream PrintLine();
    OutStream PrintLine(Obj s);

    OutStream WriteProps(Map props);
    OutStream WriteProps(Map props, Bool close);

    void Flush();

    Bool Close();

  }
}