//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   24 Sep 06  Andy Frank  Creation
//

using System;
using System.IO;

namespace Fan.Sys
{
  /// <summary>
  /// UnknownSlotErr
  /// </summary>
  public class UnknownSlotErr : Err
  {

  //////////////////////////////////////////////////////////////////////////
  // C# Convenience
  //////////////////////////////////////////////////////////////////////////

    public new static UnknownSlotErr Make(string msg)  { return Make(Str.Make(msg)); }

  //////////////////////////////////////////////////////////////////////////
  // Fan Constructors
  //////////////////////////////////////////////////////////////////////////

    public new static UnknownSlotErr Make() { return Make((Str)null, (Err)null); }
    public new static UnknownSlotErr Make(Str msg) { return Make(msg, null); }
    public new static UnknownSlotErr Make(Str msg, Err cause)
    {
      UnknownSlotErr err = new UnknownSlotErr();
      Make_(err, msg, cause);
      return err;
    }

    public static void Make_(UnknownSlotErr self) { Make_(self, null);  }
    public static void Make_(UnknownSlotErr self, Str msg) { Make_(self, msg, null); }
    public static void Make_(UnknownSlotErr self, Str msg, Err cause) { Err.Make_(self, msg, cause); }

  //////////////////////////////////////////////////////////////////////////
  // C# Constructors
  //////////////////////////////////////////////////////////////////////////

    public UnknownSlotErr(Err.Val val) : base(val) {}
    public UnknownSlotErr() : base(new UnknownSlotErr.Val()) {}

  //////////////////////////////////////////////////////////////////////////
  // Identity
  //////////////////////////////////////////////////////////////////////////

    public override Type Type() { return Sys.UnknownSlotErrType; }

  //////////////////////////////////////////////////////////////////////////
  // Val - C# Exception Type
  //////////////////////////////////////////////////////////////////////////

    public new class Val : Err.Val {}

  }
}