//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   24 Sep 06  Andy Frank  Creation
//

using System;
using System.IO;

namespace Fan.Sys
{
  /// <summary>
  /// UnknownTypeErr
  /// </summary>
  public class UnknownTypeErr : Err
  {

  //////////////////////////////////////////////////////////////////////////
  // C# Convenience
  //////////////////////////////////////////////////////////////////////////

    public new static UnknownTypeErr Make(string msg)  { return Make(Str.Make(msg)); }

  //////////////////////////////////////////////////////////////////////////
  // Fan Constructors
  //////////////////////////////////////////////////////////////////////////

    public new static UnknownTypeErr Make() { return Make((Str)null, (Err)null); }
    public new static UnknownTypeErr Make(Str msg) { return Make(msg, null); }
    public new static UnknownTypeErr Make(Str msg, Err cause)
    {
      UnknownTypeErr err = new UnknownTypeErr();
      Make_(err, msg, cause);
      return err;
    }

    public static void Make_(UnknownTypeErr self) { Make_(self, null);  }
    public static void Make_(UnknownTypeErr self, Str msg) { Make_(self, msg, null); }
    public static void Make_(UnknownTypeErr self, Str msg, Err cause) { Err.Make_(self, msg, cause); }

  //////////////////////////////////////////////////////////////////////////
  // C# Constructors
  //////////////////////////////////////////////////////////////////////////

    public UnknownTypeErr(Err.Val val) : base(val) {}
    public UnknownTypeErr() : base(new UnknownTypeErr.Val()) {}

  //////////////////////////////////////////////////////////////////////////
  // Identity
  //////////////////////////////////////////////////////////////////////////

    public override Type Type() { return Sys.UnknownTypeErrType; }

  //////////////////////////////////////////////////////////////////////////
  // Val - C# Exception Type
  //////////////////////////////////////////////////////////////////////////

    public new class Val : Err.Val {}

  }
}