//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   14 Jan 06  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// Version.
  /// </summary>
  public sealed class Version : FanObj
  {

  //////////////////////////////////////////////////////////////////////////
  // Construction
  //////////////////////////////////////////////////////////////////////////

    public static Version Parse(Str str)
    {
      /*
      List segments = new List(Sys.IntType, 4);
      String s = str.val;
      int seg = -1;
      boolean valid = true;
      int len = s.length();
      for (int i=0; i<len; ++i)
      {
        int c = s.charAt(i);
        if (c == '.')
        {
          if (seg < 0 || i+1>=len) { valid = false; break; }
          segments.add(Int.pos(seg));
          seg = -1;
        }
        else
        {
          if ('0' <= c && c <= '9')
          {
            if (seg < 0) seg = c-'0';
            else seg = seg*10 + (c-'0');
          }
          else
          {
            valid = false; break;
          }
        }
      }
      if (seg >= 0) segments.add(Int.pos(seg));
      if (!valid || segments.sz() == 0) throw ArgErr.make("Invalid Version: '" + s + "'").val;
      return new Version(segments);
      */
      return new Version(null);
    }

    public static Version Make(List segments)
    {
      /*
      bool valid = segments.Sz() > 0;
      for (int i=0; i<segments.Sz(); i++)
        if (((Int)segments.get(i)).val < 0) valid = false;
      if (!valid) throw ArgErr.Make("Invalid Version: '" + segments + "'").val;
      return new Version(segments);
      */
      return new Version(null);
    }

    Version(List segments)
    {
      this.segments = segments.RO();
    }

  //////////////////////////////////////////////////////////////////////////
  // Identity
  //////////////////////////////////////////////////////////////////////////

    public override Bool Equals(Obj obj)
    {
      if (obj is Version)
        return ToStr().Equals(((Version)obj).ToStr());
      else
        return Bool.False;
    }

    public override Int Compare(Obj obj)
    {
      /*
      Version that = (Version)obj;
      List a = this.segments;
      List b = that.segments;
      for (int i=0; i<a.sz() && i<b.sz(); ++i)
      {
        long ai = ((Int)a.get(i)).val;
        long bi = ((Int)b.get(i)).val;
        if (ai < bi) return Int.LT;
        if (ai > bi) return Int.GT;
      }
      if (a.sz() < b.sz()) return Int.LT;
      if (a.sz() > b.sz()) return Int.GT;
      */
      return Int.EQ;
    }

    public override int GetHashCode()
    {
      return ToStr().GetHashCode();
    }

    public override Int Hash()
    {
      return ToStr().Hash();
    }

    public override Type Type()
    {
      return Sys.VersionType;
    }

    public override Str ToStr()
    {
      /*
      if (str == null)
      {
        StringBuilder s = new StringBuilder();
        for (int i=0; i<segments.sz(); ++i)
        {
          if (i > 0) s.append('.');
          s.append(((Int)segments.get(i)).val);
        }
        str = Str.make(s.toString());
      }
      return str;
      */
      return Str.Make("todo");
    }

  //////////////////////////////////////////////////////////////////////////
  // Methods
  //////////////////////////////////////////////////////////////////////////

    public List Segments()
    {
      return segments;
    }

    public int Segment(int index)
    {
      return (int)((Int)segments.Get(index)).val;
    }

    public Int Major()
    {
      return (Int)segments.Get(0);
    }

    public Int Minor()
    {
      if (segments.Sz() < 2) return null;
      return (Int)segments.Get(1);
    }

    public Int Build()
    {
      if (segments.Sz() < 3) return null;
      return (Int)segments.Get(2);
    }

    public Int Patch()
    {
      if (segments.Sz() < 4) return null;
      return (Int)segments.Get(3);
    }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

    private readonly List segments;
    //private Str str;

  }
}