//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   31 Jan 07  Andy Frank  Creation
//

using Fan.Sys;
using Fanx.Fcode;

namespace Fanx.Emit
{
  /// <summary>
  /// FMixinBodyEmit emits the class body of a mixin type.
  /// </summary>
  public class FMixinBodyEmit : FClassEmit
  {

  //////////////////////////////////////////////////////////////////////////
  // Constructor
  //////////////////////////////////////////////////////////////////////////

    public FMixinBodyEmit(Emitter emitter, Type parent, FType type)
      : base(emitter, parent, type)
    {
    }

  //////////////////////////////////////////////////////////////////////////
  // Overrides
  //////////////////////////////////////////////////////////////////////////

    public override void Emit()
    {
      Init(Nname(type.selft)+"$", Base(), null, 0); //FConst.PUBLIC | FConst.FINAL);
      this.selfName = className;
      //preview();
      EmitType();

      // emit class body
      for (int i=0; i<type.fields.Length;  i++)  Emit(type.fields[i]);
      for (int i=0; i<type.methods.Length; i++)  Emit(type.methods[i]);
      EmitTypeConstFields();
    }

    protected override string Base()
    {
      return "System.Object";
    }

    //protected void emit(FField f)
    //{
    //  if ((f.flags & FConst.Static) != 0)
    //    super.emit(f);
    //}

    protected override void EmitType()
    {
      base.EmitType();

      // TODO
      PERWAPI.CILInstructions code = ctor.CreateCodeBuffer();
      code.Inst(PERWAPI.Op.ret);

      code = cctor.CreateCodeBuffer();
      code.Inst(PERWAPI.Op.ret);
    }

    protected override void Emit(FMethod m)
    {
      // TODO
      //string name = Name(m.name);
      //if (name == "static$init") { EmitStaticInit(m); return; }

      new FMethodEmit(this, m).EmitMixinBody();
    }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

  }
}