//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   30 Jan 07  Andy Frank  Creation
//

using Fan.Sys;
using Fanx.Fcode;

namespace Fanx.Emit
{
  /// <summary>
  /// FMixinInterfaceEmit emits the interface of a mixin type.
  /// </summary>
  public class FMixinInterfaceEmit : FTypeEmit
  {

  //////////////////////////////////////////////////////////////////////////
  // Constructor
  //////////////////////////////////////////////////////////////////////////

    public FMixinInterfaceEmit(Emitter emitter, Type parent, FType type)
      : base(emitter, parent, type)
    {
    }

  //////////////////////////////////////////////////////////////////////////
  // Overrides
  //////////////////////////////////////////////////////////////////////////

    public override void Emit()
    {
      //Init(Nname(type.selft), Base(), Mixins(), jflags(type.flags));
      Init(Nname(type.selft), Base(), null, 0);
      this.selfName = className;
      EmitType();
      for (int i=0; i<type.methods.Length; i++)  Emit(type.methods[i]);
    }

    /*
    String[] mixins()
    {
      String[] mixins = new String[type.mixins.length+1];
      mixins[0] = "fan/sys/Obj";
      for (int i=1; i<mixins.length; ++i)
        mixins[i] = jname(type.mixins[i-1]);
      return mixins;
    }
    */

    protected override string Base()
    {
      return null;
    }

    protected override void EmitType()
    {
      emitter.EmitClass(Base(), className, PERWAPI.TypeAttr.Interface);
    }

    protected override void Emit(FMethod m)
    {
      new FMethodEmit(this, m).EmitMixinInterface();
    }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

  }
}