//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;

namespace Fanx.Fcode
{
  /// <summary>
  /// FSlot is the read/write fcode representation of sys::Slot.
  /// </summary>
  public class FSlot
  {
    public FFacet Facet(FPod pod, string name)
    {
      return FFacet.Facet(pod, facets, name);
    }

    protected void ReadCommon(FStore.Input input)
    {
      name  = input.U2();
      flags = input.U4();
    }

    protected void ReadFacets(FStore.Input input)
    {
      int len = input.U2();
      if (len == 0)
      {
        facets = FFacet.None;
      }
      else
      {
        facets = new FFacet[len];
        for (int i=0; i<len; i++)
          facets[i] = new FFacet().Read(input);
      }
    }

    public int name;          // str index
    public int flags;         // bitmask
    public FFacet[] facets;   // meta-data
  }
}