//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   9 Jan 06  Brian Frank  Creation
//

**
** Sys provides static access to the system's environment.
**
final class Sys
{

//////////////////////////////////////////////////////////////////////////
// Constructor
//////////////////////////////////////////////////////////////////////////

  **
  ** Private constructor.
  **
  private new make()

//////////////////////////////////////////////////////////////////////////
// Environment
//////////////////////////////////////////////////////////////////////////

  **
  ** Get the command line arguments used to run the fan process
  ** as a readonly List of strings.
  **
  static Str[] args()

  **
  ** Get the environment variables as a readonly map of Str name/value
  ** pairs.  The environment map is initialized from the following
  ** sources from lowest priority to highest priority:
  **   1. shell environment variables
  **   2. Java system properties (Java VM only obviously)
  **   3. {homeDir}/lib/sys.props
  **
  static Str:Str env()

  **
  ** Get the fan home directory.
  **
  static File homeDir()

  **
  ** Get the local host name of the machine running the
  ** virtual machine process.
  **
  static Str hostName()

  **
  ** Get the user name of the user account used to run the
  ** virtual machine process.
  **
  static Str userName()

  **
  ** Terminate the current virtual machine.
  **
  static Void exit(Int status := 0)

  **
  ** Standard output stream.
  **
  static InStream in()

  **
  ** Standard output stream.
  **
  static OutStream out()

  **
  ** Standard error output stream.
  **
  static OutStream err()

}