//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Mar 06  Andy Frank  Creation
//
package fan.web;

import java.io.*;
import fan.sys.*;

/**
 * WebSysOutStream
 */
public class WebSysOutStream
  extends SysOutStream
  implements WebOutStream
{

//////////////////////////////////////////////////////////////////////////
// Constructor
//////////////////////////////////////////////////////////////////////////

  public WebSysOutStream(OutputStream out)
  {
    super(out);
  }

//////////////////////////////////////////////////////////////////////////
// WebOutStream
//////////////////////////////////////////////////////////////////////////

  public WebOutStream w(Obj obj) { return WebOutStream$.w(this, obj.toStr()); }

  public WebOutStream tab() { return WebOutStream$.tab(this, Int.make(2)); }
  public WebOutStream tab(Int i) { return WebOutStream$.tab(this, i); }

  public WebOutStream nl() { return WebOutStream$.nl(this); }

  public WebOutStream tag(Str elemName) { return WebOutStream$.tag(this, elemName, null, Bool.False); }
  public WebOutStream tag(Str elemName, Str attrs) { return WebOutStream$.tag(this, elemName, attrs, Bool.False); }
  public WebOutStream tag(Str elemName, Str attrs, Bool close) { return WebOutStream$.tag(this, elemName, attrs, close); }
  public WebOutStream tagEnd(Str elemName) { return WebOutStream$.tagEnd(this, elemName); }

  public WebOutStream docType() { return WebOutStream$.docType(this); }

  public WebOutStream html() { return WebOutStream$.html(this); }
  public WebOutStream htmlEnd() { return WebOutStream$.htmlEnd(this); }

  public WebOutStream head() { return WebOutStream$.head(this); }
  public WebOutStream headEnd() { return WebOutStream$.headEnd(this); }

  public WebOutStream title(Str s) { return WebOutStream$.title(this, s); }

  public WebOutStream css(Uri href) { return WebOutStream$.css(this, href); }
  public WebOutStream js(Uri href) { return WebOutStream$.js(this, href); }

  public WebOutStream body() { return WebOutStream$.body(this, null); }
  public WebOutStream body(Str attrs) { return WebOutStream$.body(this, attrs); }
  public WebOutStream bodyEnd() { return WebOutStream$.bodyEnd(this); }

  public WebOutStream h1(Str c) { return WebOutStream$.h1(this, c, null); }
  public WebOutStream h1(Str c, Str a) { return WebOutStream$.h1(this, c, a); }
  public WebOutStream h2(Str c) { return WebOutStream$.h2(this, c, null); }
  public WebOutStream h2(Str c, Str a) { return WebOutStream$.h2(this, c, a); }
  public WebOutStream h3(Str c) { return WebOutStream$.h3(this, c, null); }
  public WebOutStream h3(Str c, Str a) { return WebOutStream$.h3(this, c, a); }
  public WebOutStream h4(Str c) { return WebOutStream$.h4(this, c, null); }
  public WebOutStream h4(Str c, Str a) { return WebOutStream$.h4(this, c, a); }
  public WebOutStream h5(Str c) { return WebOutStream$.h5(this, c, null); }
  public WebOutStream h5(Str c, Str a) { return WebOutStream$.h5(this, c, a); }
  public WebOutStream h6(Str c) { return WebOutStream$.h6(this, c, null); }
  public WebOutStream h6(Str c, Str a) { return WebOutStream$.h6(this, c, a); }

  public WebOutStream div() { return WebOutStream$.div(this, null); }
  public WebOutStream div(Str attrs) { return WebOutStream$.div(this, attrs); }
  public WebOutStream divEnd() { return WebOutStream$.divEnd(this); }

  public WebOutStream span() { return WebOutStream$.span(this, null); }
  public WebOutStream span(Str attrs) { return WebOutStream$.span(this, attrs); }
  public WebOutStream spanEnd() { return WebOutStream$.spanEnd(this); }

  public WebOutStream p() { return WebOutStream$.p(this, null); }
  public WebOutStream p(Str attrs) { return WebOutStream$.p(this, attrs); }
  public WebOutStream pEnd() { return WebOutStream$.pEnd(this); }

  public WebOutStream pre() { return WebOutStream$.pre(this, null); }
  public WebOutStream pre(Str attrs) { return WebOutStream$.pre(this, attrs); }
  public WebOutStream preEnd() { return WebOutStream$.preEnd(this); }

  public WebOutStream code() { return WebOutStream$.code(this, null); }
  public WebOutStream code(Str attrs) { return WebOutStream$.code(this, attrs); }
  public WebOutStream codeEnd() { return WebOutStream$.codeEnd(this); }

  public WebOutStream hr() { return WebOutStream$.hr(this); }

  public WebOutStream br() { return WebOutStream$.br(this); }

  public WebOutStream a(Uri href) { return WebOutStream$.a(this, href, null); }
  public WebOutStream a(Uri href, Str attrs) { return WebOutStream$.a(this, href, attrs); }
  public WebOutStream aEnd() { return WebOutStream$.aEnd(this); }

  public WebOutStream img(Str src) { return WebOutStream$.img(this, src, null); }
  public WebOutStream img(Str src, Str attrs) { return WebOutStream$.img(this, src, attrs); }

  public WebOutStream table() { return WebOutStream$.table(this, null); }
  public WebOutStream table(Str attrs) { return WebOutStream$.table(this, attrs); }
  public WebOutStream tableEnd() { return WebOutStream$.tableEnd(this); }

  public WebOutStream tr() { return WebOutStream$.tr(this, null); }
  public WebOutStream tr(Str attrs) { return WebOutStream$.tr(this, attrs); }
  public WebOutStream trEnd() { return WebOutStream$.trEnd(this); }

  public WebOutStream td() { return WebOutStream$.td(this, null); }
  public WebOutStream td(Str attrs) { return WebOutStream$.td(this, attrs); }
  public WebOutStream tdEnd() { return WebOutStream$.tdEnd(this); }

  public WebOutStream dl() { return WebOutStream$.dl(this, null); }
  public WebOutStream dl(Str attrs) { return WebOutStream$.dl(this, attrs); }
  public WebOutStream dlEnd() { return WebOutStream$.dlEnd(this); }

  public WebOutStream dt() { return WebOutStream$.dt(this, null); }
  public WebOutStream dt(Str attrs) { return WebOutStream$.dt(this, attrs); }
  public WebOutStream dtEnd() { return WebOutStream$.dtEnd(this); }

  public WebOutStream dd() { return WebOutStream$.dd(this, null); }
  public WebOutStream dd(Str attrs) { return WebOutStream$.dd(this, attrs); }
  public WebOutStream ddEnd() { return WebOutStream$.ddEnd(this); }

  public WebOutStream ul() { return WebOutStream$.ul(this, null); }
  public WebOutStream ul(Str attrs) { return WebOutStream$.ul(this, attrs); }
  public WebOutStream ulEnd() { return WebOutStream$.ulEnd(this); }

  public WebOutStream ol() { return WebOutStream$.ol(this, null); }
  public WebOutStream ol(Str attrs) { return WebOutStream$.ol(this, attrs); }
  public WebOutStream olEnd() { return WebOutStream$.olEnd(this); }

  public WebOutStream li() { return WebOutStream$.li(this, null); }
  public WebOutStream li(Str attrs) { return WebOutStream$.li(this, attrs); }
  public WebOutStream liEnd() { return WebOutStream$.liEnd(this); }

  public WebOutStream form() { return WebOutStream$.form(this, null); }
  public WebOutStream form(Str attrs) { return WebOutStream$.form(this, attrs); }
  public WebOutStream formEnd() { return WebOutStream$.formEnd(this); }

  public WebOutStream input() { return WebOutStream$.input(this, null); }
  public WebOutStream input(Str attrs) { return WebOutStream$.input(this, attrs); }

  public WebOutStream textField() { return WebOutStream$.textField(this, null); }
  public WebOutStream textField(Str attrs) { return WebOutStream$.textField(this, attrs); }

  public WebOutStream button() { return WebOutStream$.button(this, null); }
  public WebOutStream button(Str attrs) { return WebOutStream$.button(this, attrs); }

  public WebOutStream submit() { return WebOutStream$.submit(this, null); }
  public WebOutStream submit(Str attrs) { return WebOutStream$.submit(this, attrs); }

  public WebOutStream select() { return WebOutStream$.select(this, null); }
  public WebOutStream select(Str attrs) { return WebOutStream$.select(this, attrs); }
  public WebOutStream selectEnd() { return WebOutStream$.selectEnd(this); }

  public WebOutStream option() { return WebOutStream$.option(this, null); }
  public WebOutStream option(Str attrs) { return WebOutStream$.option(this, attrs); }
  public WebOutStream optionEnd() { return WebOutStream$.optionEnd(this); }

}